#include "ActionExamples.h"

char *Target_key;

FX_ENTRYFUNC(Target_entry_action)
// FXint f(FX_AccessInfo *ai, FXentity ID, FXint64 entry)
{
	FXaction action = (FXaction)ID;
	FXhandle handle = FX_NULLID;
	FXobject controller = FX_NULLID;
	Target_state *state = NULL;

	switch(entry)
	{
	case ACT_CREATE:
		{
			if( !(state = fxDataCreate(action, &Target_key, 0, sizeof(Target_state))) )
			{
				fxMessageSend( action, "ActionExamples.mp", FX_MESSAGE_ERROR, "Target - Allocation Failure", NULL );
				return ENTRY_BREAK;
			}

			state->target = FX_NULLID;
			
		} // ACT_CREATE
		break;

	case ACT_PROCESS:
		{
			// get state data from action
			if( !(state = fxDataGet( action, &Target_key, 0)) )
			{
				fxMessageSend( action, "ActionExamples.mp", FX_MESSAGE_ERROR, "Target - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			handle = fxActionHandle( action, FX_NOFLAG );
			controller = fxHandleController( handle, FX_NOFLAG );

			if( controller && state->target )
				fxKeyTarget( controller, state->target );

		} // ACT_PROCESS
		break;

	case ACT_LOAD:
		{
			FX_Format *f = fxFormatGet( ai, "Target" );
			if(!f) return ENTRY_BREAK;

			// get state data from action
			if( !(state = fxDataGet( action, &Target_key, 0)) )
			{
				fxMessageSend( action, "ActionExamples.mp", FX_MESSAGE_ERROR, "Target - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			fxArgLoadObj( f, "target", &(state->target) );

		} // ACT_LOAD
		break;

	case ACT_SAVE:
		{
			FX_Format *f = fxFormatNew( ai, "Target", FX_NOFLAG );
			if(!f) return ENTRY_BREAK;

			// get state data from action
			if( !(state = fxDataGet( action, &Target_key, 0)) )
			{
				fxMessageSend( action, "ActionExamples.mp", FX_MESSAGE_ERROR, "Target - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			fxArgSaveObj( f, "target", state->target );
			
		} // ACT_SAVE
		break;

	}
	return ENTRY_OK;
}
