/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

  Author: Lyle Milton
  Date: 08/27/03


  Very simple fog shader

=============================================================================*/
#include "globals.h"


//Shader Callbacks,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
static FX_SHADERINITINPUTS(ShaderInitInputs);
static FX_SHADEREVALUATE(ShaderEvaluate);



//=======================================================================================
//MergeAccess
//		shader access callback
//=======================================================================================
FX_ACCESSFUNC(FrameAccess)
{
	FXshader		shader = (FXshader)ID;

	if (level==ACCESS_OBJECT)
	{
		switch(entry)
		{
			//Perform shader object creation,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
			case O_CREATE:


				//#5. Create Outputs-----------------------------------------------------------
				F_OUT_W			= fxShaderCreateOutput(shader, "Width", FX_IOTYPE_INT, 0);
				F_OUT_H			= fxShaderCreateOutput(shader, "Height", FX_IOTYPE_INT, 0);

				F_OUT_X			= fxShaderCreateOutput(shader, "Pos_X", FX_IOTYPE_INT, 0);
				F_OUT_Y			= fxShaderCreateOutput(shader, "Posy_Y", FX_IOTYPE_INT, 0);

				F_OUT_XF		= fxShaderCreateOutput(shader, "Param_X", FX_IOTYPE_FLOAT, 0);
				F_OUT_YF		= fxShaderCreateOutput(shader, "Param_Y", FX_IOTYPE_FLOAT, 0);
				//`````````````````````````````````````````````````````````````````````````````

				//#6. Set Shader Callbacks-----------------------------------------------------
				fxShaderCallback(shader, FX_SHADERFUNC_INITINPUTS, &ShaderInitInputs);
				fxShaderCallback(shader, FX_SHADERFUNC_EVALUATE, &ShaderEvaluate);
				//`````````````````````````````````````````````````````````````````````````````

				break;

			case O_DESTROY:
				break;

			default:
				break;
		}
	}
	else if (level==ACCESS_INTERFACE)
	{
		switch(entry)
		{
			case IN_CREATE:
				{
					//Assign the blocks,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
					fxInterfaceBlockSet(FX_MODE_RENDER, FX_MODE_RENDER, FX_MBLOCK_SHADER, FX_NULLID);
					fxInterfaceBlockSet(FX_MODE_RENDER, FX_MODE_RENDER, FX_MBLOCK_SPLINE, FX_NULLID);
				}
				break;

			default:
				break;
		}
	}

	return ENTRY_OK;
}




//=======================================================================================
//ShaderInitInputs
//		Initialize the shader node inputs.
//=======================================================================================
static FX_SHADERINITINPUTS(ShaderInitInputs)
{
	return;
}

//=======================================================================================
//ShaderEvaluate
//		Evaluate the shader and set the outputs.
//=======================================================================================
static FX_SHADEREVALUATE(ShaderEvaluate)
{
	int		width=0, height=0;

	fxBufferImageSize(shader_globals, &width, &height, 0);

	if (FX_OUTPUT_REQUEST(F_OUT_W))
		f_out_w = width;

	if (FX_OUTPUT_REQUEST(F_OUT_H))
		f_out_h = height;

	if (FX_OUTPUT_REQUEST(F_OUT_X))
		f_out_x = _x;

	if (FX_OUTPUT_REQUEST(F_OUT_Y))
		f_out_y = _y;

	if (FX_OUTPUT_REQUEST(F_OUT_XF))
		f_out_xf = (FXfloat)_y/width;

	if (FX_OUTPUT_REQUEST(F_OUT_YF))
		f_out_yf = (FXfloat)_x/height;

	return;
}

