#include "InterfaceExample.h"

FXcontrol Block, Area, Button, Bool, BoolButton, DragButton, Choice, String, Float, Int, DragFloat, DragInt;
FXcontrol ChannelFloat, ShaderChannelFloat, PopupList, WeightPopup, Separator1, Separator2, ObjectPopup, KeyFrame;


#define CREATE_CONTROL(ctl)		ctl = fxCC_##ctl (#ctl, NULL, ACC_NONE

#define CTL_INDENT	110
#define CTL_VSPACE	5
#define CTL_WIDTH	200

#define CTL_PLACE(ctl, index)			fxConSetPos( ctl, CTL_INDENT, (CTL_VSPACE * (index + 1)) + (CONTROL_HEIGHT * index) )

FX_ENTRYFUNC(InterfaceExample_entry_interface)
// FXint f(FX_AccessInfo *ai, FXentity ID, FXint64 entry)
{
	FXobject object = (FXobject)ID;

	switch(entry)
	{
	case IN_CREATE:
		{
			static FXchar *	ChoiceLabels[] = { "Choice 1", "Choice 2", "Choice N", NULL };
			static FXchar *	PopupListItems[] = { "Item 1", "Item 2", "Item N", NULL };

			CREATE_CONTROL( Block ), FX_NOFLAG );
			CREATE_CONTROL( Area ), CTL_WIDTH, CONTROL_HEIGHT );
			CREATE_CONTROL( Button ), CTL_WIDTH );
			CREATE_CONTROL( Bool ) );
			CREATE_CONTROL( BoolButton ), CTL_WIDTH );
			CREATE_CONTROL( DragButton ), CTL_WIDTH, DRAG_ICON_MOVE );
			CREATE_CONTROL( Choice ), 60, 5, ChoiceLabels, FX_NOFLAG );
			CREATE_CONTROL( String ), CTL_WIDTH, FX_NOFLAG );
			CREATE_CONTROL( Float ), FX_NOFLAG );
			CREATE_CONTROL( Int ), FX_NOFLAG );
			CREATE_CONTROL( DragFloat ), 0.0, 1.0, 0.01, FX_NOFLAG );
			CREATE_CONTROL( DragInt ), 0, 255, 1, FX_NOFLAG );
			CREATE_CONTROL( ChannelFloat ), FX_X_POSITION, FX_NOFLAG );
			CREATE_CONTROL( ShaderChannelFloat ), FX_CHAN_0, 0, FX_NOFLAG );
			CREATE_CONTROL( PopupList ), CTL_WIDTH, PopupListItems, FX_NOFLAG );
			CREATE_CONTROL( WeightPopup ), CTL_WIDTH );
			Separator1 = fxCC_Separator( NULL, NULL, ACC_NONE, 200, 3, FX_NO, SEPARATOR_EMBOSS );
			Separator2 = fxCC_Separator( NULL, NULL, ACC_NONE, 200, 3, FX_NO, SEPARATOR_ENGRAVE|SEPARATOR_STARTTOBLOCK|SEPARATOR_ENDTOBLOCK );
			CREATE_CONTROL( ObjectPopup ), 200, NULL, NULL, NULL, FX_NOFLAG );
			CREATE_CONTROL( KeyFrame ), FX_NOFLAG );

			CTL_PLACE( Area, 0 );
			CTL_PLACE( Button, 1 );
			CTL_PLACE( Bool, 2 );
			CTL_PLACE( BoolButton, 3 );
			CTL_PLACE( DragButton, 4 );
			CTL_PLACE( Choice, 5 );
			CTL_PLACE( String, 6 );
			CTL_PLACE( Float, 7 );
			CTL_PLACE( Int, 8 );
			CTL_PLACE( DragFloat, 9 );
			CTL_PLACE( DragInt, 10 );
			CTL_PLACE( ChannelFloat, 11 );
			CTL_PLACE( ShaderChannelFloat, 12 );
			CTL_PLACE( PopupList, 13 );
			CTL_PLACE( WeightPopup, 14 );
			CTL_PLACE( Separator1, 15 );
			CTL_PLACE( Separator2, 16 );
			CTL_PLACE( ObjectPopup, 17 );
			CTL_PLACE( KeyFrame, 18 );

		} // IN_CREATE
		break;

	}
	return ENTRY_OK;
}
