/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: PluginMain.c

  Author: YOU
  Date: DATE

  Description: 

=============================================================================*/
#define _MAINPLUGIN_FILE
#include "ScriptLists.h"


_pluginEntry
// FXint messiahEntry(FXchar pname[256], FXvoid *api_func, FXint api, FXint program, const FXchar *rev)
{

	// Get Necessary API Components	///////////////////////////////////////////
		_MESSIAH_PLUGIN_ALL("ScriptLists");
	////////////////////////////////////////////////////////////////////////////

	// Register Plugin's Modules	////////////////////////////////////////////
		//Register Commands

		//Register Functions

		// newList //
		fxFunctionDescription( "Creates a new list and returns its ID", FX_NOFLAG );
		fxFunctionRegister( "newList", FX_FUNCCLASS_GENERAL, newList_func, newList_internal, FX_ARG_INT, FX_NOFLAG );

		// deleteList //
		fxFunctionDescription( "Deletes a list (i.e. frees its memory). The list is no longer accessible after it has been deleted.", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "deleteList", FX_FUNCCLASS_GENERAL, deleteList_func, deleteList_internal, FX_ARG_INT, FX_NOFLAG );

		// getListSize //
		fxFunctionDescription( "Returns the number of elements contained in the list specified by the given ID", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListSize", FX_FUNCCLASS_GENERAL, getListSize_func, getListSize_internal, FX_ARG_INT, FX_NOFLAG );

		// getListError //
		fxFunctionDescription( "Returns 1 (true) if there was an error associated with the specified list since the last time clearListError had been called. \
If there was no error then 0 (false) is returned.", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListError", FX_FUNCCLASS_GENERAL, getListError_func, getListError_internal, FX_ARG_INT, FX_NOFLAG );

		// getListErrorString //
		fxFunctionDescription( "Returns the string representation of the last error associated with a list", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListErrorString", FX_FUNCCLASS_GENERAL, getListErrorString_func, getListErrorString_internal, FX_ARG_STRING, FX_NOFLAG );

		// clearListError //
		fxFunctionDescription( "Cleares an error from a list, subsequent calls to getListError will return 0 (false) until another error occurs", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "clearListError", FX_FUNCCLASS_GENERAL, clearListError_func, clearListError_internal, FX_ARG_INT, FX_NOFLAG );

		// sortList //
		fxFunctionDescription( "Sorts the contents of a list in accending order. If numeric = 1 (true) then the elements will be compared by their numeric value, otherwise the comparison will be textual.", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "numeric", "n", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "sortList", FX_FUNCCLASS_GENERAL, sortList_func, sortList_internal, FX_ARG_INT, FX_NOFLAG );

		// copyListToString //
		fxFunctionDescription( "Returns the contents of list as one string where each element is separated by the specified delimeter (',' for example).", FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgString( "delimeter", "d", "," , NULL, FX_NOFLAG );
		fxFunctionRegister( "copyListToString", FX_FUNCCLASS_GENERAL, copyListToString_func, copyListToString_internal, FX_ARG_STRING, FX_NOFLAG );

		// setListInt //
		fxFunctionDescription( "Sets the value of the element in the list at the specified index. \
If the list is smaller than the index it will be expanded to the size: index -1. \
In that case all of the new elements will be assigned the value passed to this function.",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "value", "val", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "setListInt", FX_FUNCCLASS_GENERAL, setListInt_func, setListInt_internal, FX_ARG_INT, FX_NOFLAG );

		// setListInt //
		fxFunctionDescription( "Sets the value of the element in the list at the specified index. \
If the list is smaller than the index it will be expanded to the size: index -1. \
In that case all of the new elements will be assigned the value passed to this function.",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionArgDouble( "value", "val", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "setListDouble", FX_FUNCCLASS_GENERAL, setListDouble_func, setListDouble_internal, FX_ARG_INT, FX_NOFLAG );

		// setListObject //
		fxFunctionDescription( "Sets the value of the element in the list at the specified index. \
If the list is smaller than the index it will be expanded to the size: index -1. \
In that case all of the new elements will be assigned the value passed to this function.",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionArgObj( "value", "val", FX_NULLID, NULL, FX_NOFLAG );
		fxFunctionRegister( "setListObject", FX_FUNCCLASS_GENERAL, setListObject_func, setListObject_internal, FX_ARG_INT, FX_NOFLAG );

		// setListString //
		fxFunctionDescription( "Sets the value of the element in the list at the specified index. \
If the list is smaller than the index it will be expanded to the size: index -1. \
In that case all of the new elements will be assigned the value passed to this function.",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionArgString( "value", "val", NULL, NULL, FX_NOFLAG );
		fxFunctionRegister( "setListString", FX_FUNCCLASS_GENERAL, setListString_func, setListString_internal, FX_ARG_INT, FX_NOFLAG );

		// getListInt //
		fxFunctionDescription( "Gets the value of the element in the list at the specified index. \
If the list is smaller than the index, -2,147,483,648 will be returned (the smallest possible value for an integer). \
In that case the list will be flagged with an error, which you can check by calling getListError. \
If getListError returns 1 (true) then you can get a text representation of the error by calling getListErrorString. \
You should then call clearListError to remove the error flag from the list",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListInt", FX_FUNCCLASS_GENERAL, getListInt_func, getListInt_internal, FX_ARG_INT, FX_NOFLAG );

		// getListDouble //
		fxFunctionDescription( "Gets the value of the element in the list at the specified index. \
If the list is smaller than the index, 1.7e-308 will be returned (the smallest possible value for a double). \
In that case the list will be flagged with an error, which you can check by calling getListError. \
If getListError returns 1 (true) then you can get a text representation of the error by calling getListErrorString. \
You should then call clearListError to remove the error flag from the list",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListDouble", FX_FUNCCLASS_GENERAL, getListDouble_func, getListDouble_internal, FX_ARG_DOUBLE, FX_NOFLAG );

		// getListObject //
		fxFunctionDescription( "Gets the value of the element in the list at the specified index. \
If the list is smaller than the index, or the object stored at the specified index is not a valid object, 0 will be returned (indicating an invalid object). \
In that case the list will be flagged with an error, which you can check by calling getListError. \
If getListError returns 1 (true) then you can get a text representation of the error by calling getListErrorString. \
You should then call clearListError to remove the error flag from the list",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListObject", FX_FUNCCLASS_GENERAL, getListObject_func, getListObject_internal, FX_ARG_OBJECT, FX_NOFLAG );
			
		// getListString //
		fxFunctionDescription( "Gets the value of the element in the list at the specified index. \
If the list is smaller than the index IT'S GONNA CRASH BABY!! (RONTODO: find return value when crash is fixed). \
In that case the list will be flagged with an error, which you can check by calling getListError. \
If getListError returns 1 (true) then you can get a text representation of the error by calling getListErrorString. \
You should then call clearListError to remove the error flag from the list",
								FX_NOFLAG );
		fxFunctionArgInt( "list", "l", 0, NULL, FX_NOFLAG );
		fxFunctionArgInt( "index", "i", 0, NULL, FX_NOFLAG );
		fxFunctionRegister( "getListString", FX_FUNCCLASS_GENERAL, getListString_func, getListString_internal, FX_ARG_STRING, FX_NOFLAG );

		
		//Register Effects

		//Register Actions

		//Register Shaders

		//Register Setup Extensions

		//Register Play Extensions

		//Register Customize Extensions

		//Register Edit Extensions

	////////////////////////////////////////////////////////////////////////////


	return FX_PLUGIN_OK;
}

_pluginExit
// FXvoid messiahExit(FXvoid)
{

}
