/*!=============================================================================
	Copyright (c) 2003 pmG WorldWide, LLC.

	\file Plugin.h
	\author Ron Griswold
	
	Created: 9/11/03

	CVS: $Revision$	$Date$

	Description:

=============================================================================*/
#ifndef PLUGIN_H
#define PLUGIN_H

#define _MESSIAH_FULL_API
#include <messiah_main.h>
#include <messiah_shader.h>

//////////////////////////////////////////////////////
// Access Globals
//////////////////////////////////////////////////////

//     ACCESS_OBJECT     //
static FXint64	Utility_object_an = O_CREATE|O_DESTROY;

//     ACCESS_INTERFACE     //
static FXint64	Utility_interface_an = IN_CREATE;

#define MERGE( a, b )					(a##b)
#define REGISTER_SHADER( name, mod )	fxModuleAccess( ACCESS_OBJECT, Utility_object_an, FX_NO ); \
										fxModuleAccess( ACCESS_INTERFACE, Utility_interface_an, FX_NO ); \
										mod = fxModuleRegister( FX_MODTYPE_SHADER, #name, MERGE( name, _Access), FX_NOFLAG ); \
										if( !mod ) fxMessageSend( FX_NULLID, "Utility Shader Registration Failed!", FX_MESSAGE_ERROR, #name, NULL ); \
										else fxMessageSend( mod, "Utility Shader Registered", FX_MESSAGE_INFO, #name, NULL )

//////////////////////////////////////////////////////
// Access Functions
//////////////////////////////////////////////////////

FX_ACCESSFUNC(Scalar_Access);
FX_ACCESSFUNC(Vector3_Access);
FX_ACCESSFUNC(Vector4_Access);

FX_ACCESSFUNC(Point_Access);

FX_ACCESSFUNC(Dot_Access);
FX_ACCESSFUNC(Cross_Access);

#endif // PLUGIN_H