/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_data.h
	Author:	Lyle Milton
	Date:	04/26/03

	------------------------------------------------------------



=============================================================================*/

#ifdef _MESSIAH_API_ARMATURE

#ifndef __MESSIAH_ARMATURE
#define __MESSIAH_ARMATURE


#ifndef __MESSIAH_HIDE_TYPES

	#define	FX_ARMDATA_MUTE			(1<<1) //armature/handle/action is bypassed
	#define FX_ARMDATA_DRAWNODE		(1<<5) //draw a clickable spot
	#define FX_ARMDATA_DRAWTEXT		(1<<6) //draw text
	#define FX_ARMDATA_DRAWLINE		(1<<7) //draw line to parent
	#define FX_ARMDATA_TACK			(1<<9) //handle stays on screen even if armature is bypassed
	#define FX_ARMDATA_COLOR		(1<<13) //handle overrides the armature color
	#define FX_ARMDATA_SETUP		(1<<20) //Setup action/armature
	#define FX_ARMDATA_ANIMATE		(1<<21) //Non-Setup action/armature

	#define FX_HANOFF_NONE			0
	#define FX_HANOFF_SCREEN		1 //pixel offset
	#define FX_HANOFF_WORLD			2 //world space offset
	#define FX_HANOFF_LOCAL			3 //local space offset - ONLY if there is a controller

	#define FX_HANPOS_WORLD			0 //world position
	#define FX_HANPOS_SCREEN		1 //locked to a screen location
	#define FX_HANPOS_PARENTHANDLE	2 //locked to the parent handle

	#define FX_HANMBUTTON_LEFT		0
	#define FX_HANMBUTTON_MIDDLE	1
	#define FX_HANMBUTTON_RIGHT		2


	//for use with fx*Find
	#define FX_ARMFIND_LOAD			(1<<0)


	#define FX_COORD_LOCAL			0
	#define FX_COORD_PARENT			1
	#define FX_COORD_WORLD			2
	#define FX_COORD_SCREEN			3

	//screen aligments
	//VERTICAL
	#define FX_HANSCREEN_BOTTOM		0
	#define FX_HANSCREEN_CENTERV	1
	#define FX_HANSCREEN_TOP		2

	//HORIZONTAL
	#define FX_HANSCREEN_LEFT		0
	#define FX_HANSCREEN_CENTERH	1
	#define FX_HANSCREEN_RIGHT		2

#endif //__MESSIAH_HIDE_TYPES





FX_API(FXarmature, fxArmatureCreate)(FXchar *name, FXint flags);

FX_API(FXint, fxArmatureDelete)(FXarmature, FXint flags);

FX_API(FXint, fxArmatureName)(FXarmature, FXchar *buffer, FXint buffer_length, FXint flags);

FX_API(FXint, fxArmatureRename)(FXarmature, FXchar *name, FXint flags);

FX_API(FXint, fxArmatureOptions)(FXarmature, FXint *opt, FXint flags);

FX_API(FXint, fxArmatureOptionsSet)(FXarmature, FXint opt, FXint flags);

FX_API(FXint, fxArmatureOptionsClear)(FXarmature, FXint opt, FXint flags);

FX_API(FXarmature, fxArmatureFind)(FXchar *name, FXint flags);

FX_API(FXhandle, fxHandleFind)(FXchar *name, FXint flags);

FX_API(FXhandle, fxHandleCreate)(FXchar *name, FXarmature, FXhandle pID, FXint flags);

FX_API(FXint, fxHandleDelete)(FXhandle, FXint flags);

FX_API(FXint, fxHandleSetPixelSize)(FXhandle, FXdouble draw_size, FXdouble hotspot_size, FXint flags);

FX_API(FXint, fxHandleName)(FXhandle, FXchar *buffer, FXint buffer_length, FXint flags);

FX_API(FXint, fxHandleRename)(FXhandle, FXchar *name, FXint flags);

FX_API(FXint, fxHandleText)(FXhandle, FXchar *buffer, FXint buffer_length, FXint flags);

FX_API(FXint, fxHandleTextSet)(FXhandle, FXchar *text, FXint flags);

FX_API(FXint, fxHandleColor)(FXhandle, FXfloat color[3], FXint flags);

FX_API(FXint, fxHandleColorSet)(FXhandle, FXfloat color[3], FXint flags);

FX_API(FXint, fxHandlePos)(FXhandle, FXvecd pos, FXint flags);

FX_API(FXint, fxHandlePosSet)(FXhandle, FXvecd pos, FXint flags);

FX_API(FXint, fxHandleOffset)(FXhandle, FXvecd offset, FXint flags);

FX_API(FXint, fxHandleOffsetSet)(FXhandle, FXvecd offset, FXint flags);

FX_API(FXint, fxHandleTShift)(FXhandle, FXveci shift, FXint flags);

FX_API(FXint, fxHandleTShiftSet)(FXhandle, FXveci shift, FXint flags);

FX_API(FXint, fxHandleOptions)(FXhandle, FXint *opt, FXint flags);

FX_API(FXint, fxHandleOptionsSet)(FXhandle, FXint opt, FXint flags);

FX_API(FXint, fxHandleOptionsClear)(FXhandle, FXint opt, FXint flags);

FX_API(FXint, fxHandlePosType)(FXhandle, FXint *type, FXint flags);

FX_API(FXint, fxHandlePosTypeSet)(FXhandle, FXint type, FXint flags);

FX_API(FXint, fxHandleOffType)(FXhandle, FXint *type, FXint flags);

FX_API(FXint, fxHandleOffTypeSet)(FXhandle, FXint type, FXint flags);

FX_API(FXobject, fxHandleController)(FXhandle, FXint flags);

FX_API(FXint, fxHandleControllerSet)(FXhandle, FXobject, FXint flags);

FX_API(FXhandle, fxHandleActive)(FXint flags);

FX_API(FXaction, fxHandleActiveAction)(FXint flags);

FX_API(FXint, fxHandleMouseButton)(FXint flags);

FX_API(FXint, fxHandleMouseVector)(FXhandle, FXvecd return_vector, FXvecd normal, FXint coord_sys, FXint flags);

FX_API(FXint, fxHandleMouseXForm)(FXhandle, FXint flags);

FX_API(FXint, fxHandleMouseOffset)(FXhandle, FXint *x, FXint *y, FXint flags);

FX_API(FXint, fxHandleMouseCurPos)(FXhandle, FXint *x, FXint *y, FXint flags);

FX_API(FXint, fxHandleMousePrevPos)(FXhandle, FXint *x, FXint *y, FXint flags);

FX_API(FXint, fxHandleIconSet)(FXhandle, FXimage, FXchar *name, FXint flags);

FX_API(FXint, fxHandleIconActiveSet)(FXhandle, FXimage, FXchar *name, FXint flags);

FX_API(FXint, fxHandleLineWidth)(FXhandle, FXint flags);

FX_API(FXint, fxHandleLineWidthSet)(FXhandle, FXint width, FXint flags);

FX_API(FXint, fxHandleLineStipple)(FXhandle, FXint flags);

FX_API(FXint, fxHandleLineStippleSet)(FXhandle, FXint stippleID, FXint flags);


FX_API(FXarmature, fxArmatureFirst)(FXint flags);

FX_API(FXarmature, fxArmatureNext)(FXarmature, FXint flags);

FX_API(FXarmature, fxArmaturePrev)(FXarmature, FXint flags);

FX_API(FXhandle, fxHandleFirst)(FXarmature, FXint flags);

FX_API(FXhandle, fxHandleNext)(FXhandle, FXint flags);

FX_API(FXhandle, fxHandlePrev)(FXhandle, FXint flags);

FX_API(FXhandle, fxHandleChild)(FXhandle, FXint flags);

FX_API(FXhandle, fxHandleParent)(FXhandle, FXint flags);

FX_API(FXarmature, fxHandleArmature)(FXhandle, FXint flags);

FX_API(FXint, fxHandleLink)(FXhandle hID, FXarmature, FXhandle parent, FXhandle next, FXhandle prev, FXint flags);

FX_API(FXint, fxHandleHAlignSet)(FXhandle, FXint alignment, FXint flags);

FX_API(FXint, fxHandleVAlignSet)(FXhandle, FXint alignment, FXint flags);

#define _MESSIAH_PTR_ARMATURE	messiah_apicomponent = FX_APIFUNCS_ARMATURE;\
								FX_PTR(fxArmatureCreate);\
								FX_PTR(fxArmatureDelete);\
								FX_PTR(fxArmatureName);\
								FX_PTR(fxArmatureRename);\
								FX_PTR(fxArmatureOptions);\
								FX_PTR(fxArmatureOptionsSet);\
								FX_PTR(fxArmatureOptionsClear);\
								FX_PTR(fxArmatureFind);\
								FX_PTR(fxHandleFind);\
								FX_PTR(fxHandleCreate);\
								FX_PTR(fxHandleDelete);\
								FX_PTR(fxHandleName);\
								FX_PTR(fxHandleRename);\
								FX_PTR(fxHandleText);\
								FX_PTR(fxHandleTextSet);\
								FX_PTR(fxHandleColor);\
								FX_PTR(fxHandleColorSet);\
								FX_PTR(fxHandlePos);\
								FX_PTR(fxHandlePosSet);\
								FX_PTR(fxHandleOffset);\
								FX_PTR(fxHandleOffsetSet);\
								FX_PTR(fxHandleTShift);\
								FX_PTR(fxHandleTShiftSet);\
								FX_PTR(fxHandleOptions);\
								FX_PTR(fxHandleOptionsSet);\
								FX_PTR(fxHandleOptionsClear);\
								FX_PTR(fxHandlePosType);\
								FX_PTR(fxHandlePosTypeSet);\
								FX_PTR(fxHandleOffType);\
								FX_PTR(fxHandleOffTypeSet);\
								FX_PTR(fxHandleController);\
								FX_PTR(fxHandleControllerSet);\
								FX_PTR(fxHandleActive);\
								FX_PTR(fxHandleActiveAction);\
								FX_PTR(fxHandleMouseButton);\
								FX_PTR(fxHandleMouseVector);\
								FX_PTR(fxHandleMouseXForm);\
								FX_PTR(fxHandleMouseOffset);\
								FX_PTR(fxHandleMouseCurPos);\
								FX_PTR(fxHandleMousePrevPos);\
								FX_PTR(fxHandleIconSet);\
								FX_PTR(fxHandleIconActiveSet);\
								FX_PTR(fxHandleLineWidth);\
								FX_PTR(fxHandleLineWidthSet);\
								FX_PTR(fxHandleLineStipple);\
								FX_PTR(fxHandleLineStippleSet);\
								FX_PTR(fxArmatureFirst);\
								FX_PTR(fxArmatureNext);\
								FX_PTR(fxArmaturePrev);\
								FX_PTR(fxHandleFirst);\
								FX_PTR(fxHandleNext);\
								FX_PTR(fxHandlePrev);\
								FX_PTR(fxHandleChild);\
								FX_PTR(fxHandleParent);\
								FX_PTR(fxHandleArmature);\
								FX_PTR(fxHandleLink);\
								FX_PTR(fxHandleSetPixelSize);\
								FX_PTR(fxHandleHAlignSet);\
								FX_PTR(fxHandleVAlignSet)




#endif //__MESSIAH_ARMATURE


#endif //_MESSIAH_API_ARMATURE


