/*=============================================================================
	Copyright (c) 1999-2003 pmG Worldwide, LLC.

	File:	messiah_function.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 05/09/03 - LM
			- added "FXint flags" to all fxFunctionArg*s
				+ this is done to allow for upcoming features
			- added Armature class name

=============================================================================*/


#ifdef _MESSIAH_API_FUNCTION

#ifndef __MESSIAH_FUNC
#define __MESSIAH_FUNC

#ifndef	__MESSIAH_HIDE_TYPES

	#define FX_FUNCCLASS_GENERAL	"General"
	#define FX_FUNCCLASS_FILE		"File"
	#define FX_FUNCCLASS_MOTION		"Motion"
	#define FX_FUNCCLASS_IK			"IK"
	#define FX_FUNCCLASS_OBJECT		"Object"
	#define FX_FUNCCLASS_TOOL		"Tool"
	#define FX_FUNCCLASS_EFFECT		"Effect"
	#define FX_FUNCCLASS_SHADER		"Shader"
	#define FX_FUNCCLASS_SETUP		"Setup"
	#define FX_FUNCCLASS_RENDER		"Render"
	#define FX_FUNCCLASS_PLAY		"Play"
	#define FX_FUNCCLASS_COMMAND	"Command"
	#define FX_FUNCCLASS_COMPOSE	"Compose"
	#define FX_FUNCCLASS_INTERFACE	"Interface"
	#define FX_FUNCCLASS_ARMATURE	"Armature"


	//Function flags for fxFunctionRegister,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_FUNC_SCRIPTSONLY		(1<<2)	//The expression function may only be called by scripts

	#define FX_EXPFUNC(f, dt, ed)	FXintf f(FX_Arg *return_arg, dt *ed)

#endif	//__MESSIAH_HIDE_TYPES


//Expression function return values--------------------------------------------
#define FX_FUNC_OK		1	//function library succeeded
#define FX_FUNC_FAIL	0	//function library failed to compute or something went wrong
//`````````````````````````````````````````````````````````````````````````````


FX_API(FXint, fxFunctionRegister)(FXchar *name, FXchar *func_class, FXint (*exp)(FX_Arg*, FXvoid*), FXvoid *func, FXint return_type, FXint flags);

FX_API(FXint, fxFunctionDescription)(FXchar *desc, FXint flags);

FX_API(FXint, fxFunctionArgInt)(FXchar *name, FXchar *abbr, FXint def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgDouble)(FXchar *name, FXchar *abbr, FXdouble def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgFloat)(FXchar *name, FXchar *abbr, FXfloat def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgInt3)(FXchar *name, FXchar *abbr, FXint def1, FXint def2, FXint def3, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgDouble3)(FXchar *name, FXchar *abbr, FXdouble def1, FXdouble def2, FXdouble def3, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgFloat3)(FXchar *name, FXchar *abbr, FXfloat def1, FXfloat def2, FXfloat def3, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgInt4)(FXchar *name, FXchar *abbr, FXint def1, FXint def2, FXint def3, FXint def4, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgDouble4)(FXchar *name, FXchar *abbr, FXdouble def1, FXdouble def2, FXdouble def3, FXdouble def4, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgFloat4)(FXchar *name, FXchar *abbr, FXfloat def1, FXfloat def2, FXfloat def3, FXfloat def4, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgChar)(FXchar *name, FXchar *abbr, FXchar def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgString)(FXchar *name, FXchar *abbr, FXchar *def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgStringList)(FXchar *name, FXchar *abbr, FXchar **def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgVoid)(FXchar *name, FXchar *abbr, FXvoid *def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgDP)(FXchar *name, FXchar *abbr, FXvoid **def, FXchar *def_exp, FXint flags);

FX_API(FXint, fxFunctionArgObj)(FXchar *name, FXchar *abbr, FXobject def, FXchar *def_exp, FXint flags);



#define _MESSIAH_PTR_FUNCTION	messiah_apicomponent = FX_APIFUNCS_FUNCTION;\
								FX_PTR(fxFunctionRegister);\
								FX_PTR(fxFunctionDescription);\
								\
								FX_PTR(fxFunctionArgInt);\
								FX_PTR(fxFunctionArgDouble);\
								FX_PTR(fxFunctionArgFloat);\
								FX_PTR(fxFunctionArgInt3);\
								FX_PTR(fxFunctionArgDouble3);\
								FX_PTR(fxFunctionArgFloat3);\
								FX_PTR(fxFunctionArgInt4);\
								FX_PTR(fxFunctionArgDouble4);\
								FX_PTR(fxFunctionArgFloat4);\
								FX_PTR(fxFunctionArgChar);\
								FX_PTR(fxFunctionArgString);\
								FX_PTR(fxFunctionArgStringList);\
								FX_PTR(fxFunctionArgVoid);\
								FX_PTR(fxFunctionArgDP);\
								FX_PTR(fxFunctionArgObj)

#endif //__MESSIAH_FUNC

#endif //_MESSIAH_API_FUNCTION

